// book, recipe, edit (with recipe), edit-new (without recipe)
var currentDisplay;
var currentRecipe;
var defaultPageTitle = 'Herzlich willkommen und frohes Kochvergn&uuml;gen!';
var editors; // cleditors
var searchidx; // search index is created first accessed

function changeButtonPanel(newDisplay) {
	if (currentDisplay) {
		j('.' + currentDisplay.toString).removeClass('active');
		j('.' + currentDisplay.toString).parent().off('mouseup');
	}
	
	j('.' + newDisplay.toString).addClass('active');
	j('.' + newDisplay.toString).parent().on('mouseup', '.' + newDisplay.toString, function() {clickButton(j(this).attr('id'))});
}

function clickButton(id) {
	if (id == 'button_new') {
		changeDisplay(displayEditNew);
	} else if (id == 'button_edit') {
		changeDisplay(displayEdit, 300);
	} else if (id == 'button_delete' && currentRecipe) {
		j.confirm({
			title: '',
			content: 'Rezept ' + currentRecipe.title + ' wirklich löschen?',
			boxWidth: '360px',
			useBootstrap: false,
			buttons: {
				'Nein, blo&szlig; nicht!': doNothing,
				'Ja, bitte!': function() {
					document.deleteForm['recipe.path'].value = currentRecipe.path;
					document.deleteForm.submit();
				}}
		});
	} else if (id == 'button_save') {
		validateAndSubmitForm();
	} else if (id == 'cookbook_title') {
		editCookbookTitle(true);
	}
}

function editCookbookTitle(switchOn) {
	var pCookbookTitle = j('#cookbook_title');
	var tfCookbookTitle = j('#cookbook_title_textfield');
	if (switchOn != false && pCookbookTitle.hasClass('active')) {
		pCookbookTitle.hide();
		tfCookbookTitle.show();
	} else {
		pCookbookTitle.show();
		tfCookbookTitle.hide();
	}
}

function changeDisplay(display, delay) {
	if (!delay) delay = 0;
	
	var doDisplayNew = function() {
		changeButtonPanel(display);
		currentDisplay = display;
		display.show(delay);
	};
	
	if (currentDisplay) {
		var doSwitchDisplay = function() {
			currentDisplay.hide(delay)
			j('#wrapper').promise().done(function() {doDisplayNew()});
		};
		
		if (currentDisplay.confirmChange) {
			currentDisplay.confirmChange(doSwitchDisplay, delay);
		} else {
			doSwitchDisplay();
		}
	} else {
		doDisplayNew();
	}
}

// display definitions
// properties
// toString: mandatory, defines classes to activated
// show(delay): mandatory, function showing the display
// hide(delay): mandatory, function hiding the display
// confirmChange(doConfirmed, delay): optional, function verifying change allowed and invokes doConfirmed if so 

var displayBook = {
		toString: 'book',
		show: delay => j('#page-title').html(defaultPageTitle),
		hide: function(delay) {}
	};

var displayEditNew = {
		toString: 'edit-new',
		show: function(delay) {
			j('#page-title').html('Neues Rezept erstellen');
			j('.editor').val('');
			j('.widget_edit').show(delay);
			j('#cookbook_title_textfield').val(db.cookbook);
			if (db.cookbook == '') clickButton('cookbook_title');
			j('#recipeForm').find('input[name="recipe.path"]').val('');
			
			// editors must be updated in displayed mode!
			j('.widget_edit').promise().done(function() {updateEditor('')});
		},
		confirmChange: function(doConfirmed, delay) {
			var warnForSaving = false;
			j('.editor,recipe_ingredients_left_edit,recipe_ingredients_right_edit,recipe_preparing_edit').each(function() {
				if (j(this).attr('id') == 'cookbook_title_textfield') {
					warnForSaving |= j(this).val() != db.cookbook;
				} else {
					warnForSaving |= j(this).val() != '';
				}
			});
			
			if (warnForSaving) {
				j.confirm({
					title: '',
					content: 'Wollen Sie das Rezept noch speichern?<br/>Die Daten gehen sonst verloren!',
					boxWidth: '360px',
					useBootstrap: false,
					buttons: {
						'Nein, ich hab\'s mir &uuml;berlegt': function() {doConfirmed()},
						'Ja!': function() {scrollTo('#header')}
					}
				});
			} else {
				doConfirmed();
			}
		},
		hide: function(delay) {
			j('#page-title').html(defaultPageTitle);
			j('.widget_edit').hide(delay);
			j('.textfield').css('background', '#fff');
			getEditors().forEach(function(editor) {editor.$frame.css('background', '#fff')});
			editCookbookTitle(false);
		}
	};

var displayRecipe = {
		toString: 'recipe',
		show: function(delay) {
			j('#page-title').html(currentRecipe.title);
			var ingredients = j('#ingredients');
			if (currentRecipe.ingredientsLeft != '' || currentRecipe.ingredientsRight != '') {
				ingredients.find('#ingredientstitle').html('Man nehme ' + currentRecipe.ingredientsAddition);
				ingredients.find('.footer-widget-column:eq(0)').html(currentRecipe.ingredientsLeft);
				ingredients.find('.footer-widget-column:eq(1)').html(currentRecipe.ingredientsRight);
				ingredients.show(delay);
			}
			var preparing = j('#preparing');
			preparing.find('#preparingtitle').html('Zubereitung ' + currentRecipe.preparingAddition);
			preparing.find('div:eq(0)').html(currentRecipe.preparing);
			preparing.show(delay);
			
			j('#tab-' + db.sections.indexOf(currentRecipe.section) + ':visible').click();
			var mainMenu = j('#mainnav-menu');
			if (mainMenu.is(':visible')) j('#mainnav-toggle').click();
			mainMenu.promise().done(function() {scrollTo('#header')});
		},
		hide: function(delay) {
			j('#ingredients,#preparing').hide(delay);
			j('#page-title').html(defaultPageTitle);
		}
	};

var displayEdit = {
		toString: 'edit',
		recipe: null, // the edited recipe
		show: function(delay) {
			this.recipe = currentRecipe;
			j('#page-title').html('Rezept bearbeiten');
			j('#cookbook_title_textfield').val(db.cookbook);
			j('#section_title_edit').val(this.recipe.section.title);
			j('#recipe_short_title_edit').val(this.recipe.shortTitle);
			j('#recipe_title_edit').val(this.recipe.title);
			j('#recipe_ingredients_addition_edit').val(this.recipe.ingredientsAddition);
			j('#recipe_preparing_addition_edit').val(this.recipe.preparingAddition);
			j('#recipeForm').find('input[name="recipe.path"]').val(this.recipe.path);
			
			j('.widget_edit').show(delay);
			
			// editors must be updated in displayed mode!
			j('.widget_edit').promise().done(function() {
				updateEditor(currentRecipe.ingredientsLeft, 'recipe_ingredients_left_edit')
				updateEditor(currentRecipe.ingredientsRight, 'recipe_ingredients_right_edit')
				updateEditor(currentRecipe.preparing, 'recipe_preparing_edit')
				j('#tab-' + db.sections.indexOf(currentRecipe.section) + ':visible').click();
				if (j('#mainnav-menu').is(':visible')) j('#mainnav-toggle').click();
				scrollTo('#header');
			});
		},
		confirmChange: function(doConfirmed, delay) {
			var equals = function(id, value) {
				return j('#' + id).val() == value;
			};
			
			var warnForSaving = !equals('cookbook_title_textfield', db.cookbook) ||
				!equals('section_title_edit', this.recipe.section.title) ||
				!equals('recipe_short_title_edit', this.recipe.shortTitle) ||
				!equals('recipe_title_edit', this.recipe.title) ||
				!equals('recipe_ingredients_addition_edit', this.recipe.ingredientsAddition) ||
				!equals('recipe_preparing_addition_edit', this.recipe.preparingAddition) ||
				!equals('recipe_ingredients_left_edit', this.recipe.ingredientsLeft) ||
				!equals('recipe_ingredients_right_edit', this.recipe.ingredientsRight) ||
				!equals('recipe_preparing_edit', this.recipe.preparing);
			if (warnForSaving) {
				j.confirm({
					title: '',
					content: 'Wollen Sie das Rezept noch speichern?<br/>&Auml;nderungen gehen sonst verloren!',
					boxWidth: '360px',
					useBootstrap: false,
					buttons: {
						'Nein, ich hab\'s mir &uuml;berlegt': function() {doConfirmed()},
						'Ja!': function() {scrollTo('#header')}
					}
				});
			} else {
				doConfirmed();
			}
		},
		hide: function(delay) {
			j('#page-title').html(defaultPageTitle);
			j('.widget_edit').hide(delay);
			j('.textfield').css('background', '#fff')
			getEditors().forEach(function(editor) {editor.$frame.css('background', '#fff')});
			editCookbookTitle(false);
		}
	};

function validateAndSubmitForm()
{
	var hasErrors = false;
	var errorColor = '#ffaa80';
	
	var validateNonEmpty = function(field) {
		if (field.val() == '') {
			field.css('background', errorColor);
			hasErrors = true;
		} else {
			field.css('background', '#fff');
		};
	}
	
	// copy cookbook title from textfield to hidden field
	j('#cookbook_title_edit').val(j('#cookbook_title_textfield').val())
	validateNonEmpty(j('#cookbook_title_textfield'));
	
	var form = j('#recipeForm');
	validateNonEmpty(form.find('#recipe_title_edit'));
	validateNonEmpty(form.find('#section_title_edit'));

	var recipePreparing = form.find('#recipe_preparing_edit');
	if (recipePreparing.val() == '') {
		getEditors('recipe_preparing_edit').$frame.css('background', errorColor);
		hasErrors = true;
	} else {
		getEditors('recipe_preparing_edit').$frame.css('background', '#fff');
	}
	
	if (hasErrors == true) {
		j.confirm({
			title: '',
			content: 'Bitte die rot markierten Felder ausfüllen!',
			boxWidth: '360px',
			useBootstrap: false,
			buttons: {'Ok, mach ich': doNothing}
		});
	} else {
		if (j('#recipe_short_title_edit').val() == '') {
			j('#recipe_short_title_edit').val(j('#recipe_title_edit').val());
		}
		j('#passivate_screen').fadeIn(300, function() {form.submit()});
	}
}

function showRecipe(recipeID) {
	var recipe = db.recipes[recipeID];
	if (recipe) {
		currentRecipe = recipe;
		changeDisplay(displayRecipe, 300);
	} else {
		alert("Rezept nicht gefunden");
	}
}

function search(query) {
	if (!searchidx) {
		var searchidxConfig = function () {
		  this.setRef('path');
		  this.addField('title');
		  this.addField('preparing');
		  this.addField('ingredients');
		};
		
		searchidx = {};
		['de', 'ru'].forEach(function(language) {
			searchidx[language] = elasticlunr(searchidxConfig, elasticlunr[language]);
			db.recipes.forEach(function (recipe) {
				searchidx[language].addDoc({
					path: recipe.path,
					title: recipe.title,
					preparing: recipe.preparing,
					ingredients: recipe.ingredientsLeft + ' ' + recipe.ingredientsRight
				});
			});
		});
	}
	
	// remove existing result
	var searchResult = j('#searchresult');
	searchResult.hide(300);
	searchResult.addClass("active");
	searchResult.find('h5').closest('div').remove();
	searchResult.find('.accordion-toggle').removeClass('active');
	
	// perform search
	var userConfig = {
		    fields: {
		        title: {boost: 3},
		        preparing: {boost: 2},
		        ingredients: {boost: 1}
		    },
		    bool: 'OR',
		    expand: true
		};
	var results = searchidx.de.search(query, userConfig).concat(searchidx.ru.search(query, userConfig));
	results.sort(function(first, second) {return second.score - first.score});
	
	if (results.length == 0) {
		searchResult.append('<div class="textwidget entry"><h5>Leider konnten keine passenden Rezepte gefunden werden</h5></div>');
		searchResult.show(300);
	} else if (results.length == 1) {
		showRecipe(results[0].doc.path);
	} else  {
		var maxResultSize = 10;
		results.forEach(function (result, index) {
			if (index < maxResultSize) {
				var recipe = db.recipes[result.doc.path];
				var text = recipe.preparing;
				if (text.length > 100) text = text.substring(0, 100).trim() + '...';
				searchResult.append('<div class="textwidget entry result" onclick="javascript:showRecipe(\'' + recipe.path + '\')">' +
						'<h5>' + recipe.shortTitle + '</h5>' + '<blockquote>' + text + '</blockquote></div>');
			} else if (index == maxResultSize) {
				searchResult.append('<div class="textwidget entry"><h5>Und ' + (results.length - maxResultSize) + ' weitere ...</h5></div>');
			}
		});
		searchResult.show(300);
		scrollTo('#search');
	}
	
	searchResult.promise().done(function() {j('#searchfor').autocomplete("close")});
}

/**
 * Get the editor by specified tag id.
 * @param id The tag id the editor belongs to
 * @returns The editor or the editors array if no id provided
 */
function getEditors(id) {
	if (!editors) {
		editors = [j('#recipe_preparing_edit').cleditor({
				height: 360,
				controls:
					"bold italic underline strikethrough subscript superscript | font size " +
					"style | color highlight removeformat | bullets numbering | outdent " +
					"indent | alignleft center alignright justify | undo redo | " +
					"rule | cut copy paste pastetext",
				bodyStyle:
					"margin:4px; font-family:'Open Sans', Arial, Verdana; color:#252525; cursor:text"
			})[0]];
		editors['recipe_preparing_edit'] = editors[0];
		
		['recipe_ingredients_left_edit', 'recipe_ingredients_right_edit'].forEach(function (id) {
			editors[id] = j('#' + id).cleditor({
				height: 160,
				controls: "bold italic underline strikethrough subscript superscript | bullets numbering",
				bodyStyle: "margin:4px; font-family:'Open Sans', Arial, Verdana; color:#252525; cursor:text"
			})[0];
			editors.push(editors[id]);
		});
	}
	
	return id ? editors[id] : editors;
}

/**
 * Update the editor with given value.
 * @param val The editor value.
 * @param id The editor id. If not provided all editors are updated.
 */
function updateEditor(val, id) {
	update = function(editor) {
		j(editor.$area).val(val);
		editor.updateFrame();
	}
	
	if (!id) {
		getEditors().forEach(function(editor) {
			update(editor);
		})
	} else {
		update(getEditors(id));
	}
}

function alert(message) {
	j.confirm({
		title: '',
		content: message ? message : 'No message',
		boxWidth: '360px',
		useBootstrap: false,
		buttons: {'Ok': doNothing}
	});
}

function scrollTo(selector) {
	j('html, body').animate({
		scrollTop: j(selector).first().offset().top
	}, 900);
}

function doNothing() {};
