<?php
$dbName = "cb.db";
$authPassword = "test";

$dynamic = "true";
$message = "";
$recipePath = "";

// handle request parameters
handleRequest();

// use index.html as template and insert dynamic data
$templatefile = '_index.html';
$page = file_get_contents($templatefile);
$page = preg_replace("/<!-- db\.js start -->(.)*<!-- db\.js end -->/", "",
		str_replace(array("// php.js", "$!dynamic", "$!message", "$!recipePath"), array(dbJs().passwordJs(), $dynamic, $message, $recipePath), $page));
echo $page;


/**
 * Create database connection.
 */
function dbConnect() {
	$db = class_exists("SQLite3") ?
				new class extends SQLite3 {
					public function __construct() {
						parent::__construct($GLOBALS['dbName']);
					}
					// PDO like behaviour
					public function query($sql) {
						$sqlite3result = parent::query($sql);
						$resultArray = array();
						while ($row = $sqlite3result->fetchArray()) {
							array_push($resultArray, $row);
						}
						return $resultArray;
					}
				} :
				new class extends PDO {
					public function __construct() {
						parent::__construct('sqlite:'.$GLOBALS['dbName']);
						parent::setAttribute(PDO::ATTR_ERRMODE, PDO::ERRMODE_EXCEPTION);
					}
					// SQLite3 like behaviour
					public function exec($sql) {
						return parent::exec($sql) > 0;
					}
				};
	$db -> exec("CREATE TABLE IF NOT EXISTS recipes (path, title, short_title, ingredients_addition, ingredients_left, ingredients_right, preparing_addition, preparing, section_path, primary key(path))");
	$db -> exec("CREATE TABLE IF NOT EXISTS sections (path, title, primary key(path))");
	return $db;
}

/**
 * Verify authentication.
 */
function isAuthenticated() {
	if ($GLOBALS['dynamic'] != "true") {
		return true;
	} else if (empty($_POST) || $_POST["auth"] != $GLOBALS['authPassword']) {
		return false;
	} else {
		return true;
	}
}

/**
 * Handle the request post parameters.
 */
function handleRequest() {
	if (empty($_POST)) {
		return;
	}
	
	global $message, $recipePath;
	if (!isAuthenticated()) {
		$message = "Ung&uuml;tiges Kennwort";
		return;
	}
	
	$conn = dbConnect();
	$action = $_POST["action"];
	if ($action == "save") {
		
		// delete recipe if exists and determine recipe path
		$recipePath = $_POST["recipe_path"];
		if ($recipePath != "") {
			$conn -> exec("DELETE FROM recipes WHERE path = '".$recipePath."'");
		} else {
			$recipePath = uniqid("r_", true);
		}

		$conn -> exec("REPLACE INTO sections (path, title) VALUES('cb', '".str_replace("'", "''", $_POST["cookbook_title"])."');");
		
		// determine section path
		$sectionPath = "";
		foreach ($conn -> query("SELECT path FROM sections where title = '".str_replace("'", "''", $_POST["section_title"])."'") as $res) {
			$sectionPath = $res["path"];
		}
		
		if ($sectionPath == "") {
			$sectionPath = uniqid("s_", true);
			$conn -> exec("REPLACE INTO sections (path, title) VALUES('".$sectionPath."', '".str_replace("'", "''", $_POST["section_title"])."');");
		}
		
		if ($conn -> exec("REPLACE INTO recipes (path, title, short_title, ingredients_addition, ingredients_left, ingredients_right, preparing_addition, preparing, section_path) ".
				"VALUES ('".$recipePath."','".str_replace("'", "''", $_POST["recipe_title"])."','".str_replace("'", "''", $_POST["recipe_shortTitle"])."','".
				str_replace("'", "''", $_POST["recipe_ingredients_addition"])."','".str_replace("'", "''", $_POST["recipe_ingredients_left"])."','".str_replace("'", "''", $_POST["recipe_ingredients_right"])."','".
				str_replace("'", "''", $_POST["recipe_preparing_addition"])."','".str_replace("'", "''", $_POST["recipe_preparing"])."','".$sectionPath."');")) {
			$message = "Das Rezept wurde gespeichert";
		} else {
			$message = "Das Rezept konnte nicht gespeichert werden.";
		}
	}
	else if ($action == "delete") {
		if ($conn -> exec("DELETE FROM recipes WHERE path = '".$_POST["recipe_path"]."'")) {
			$message = "Das Rezept wurde gel&ouml;scht";
		} else {
			$message = "Das Rezept konnte nicht gel&ouml;scht werden.";
		}
	}

	$conn -> exec("DELETE FROM sections WHERE path LIKE 's_%' AND path NOT IN (SELECT DISTINCT section_path FROM recipes);");
}

/**
 * Generate db.js content to be inserted directly into php.
 */
function dbJs() {
	$conn = dbConnect();
	
	$cb = "";
	foreach ($conn -> query("SELECT title FROM sections where path = 'cb'") as $res) {
		$cb = $res["title"];
	}
	
	$dbJs = "var db = {".
			"createdOn : '".date("d.m.Y", filemtime($GLOBALS['dbName']))."',".
			"cookbook : '".str_replace("'", "\'", $cb)."',".
			"sections : [";
	
	foreach ($conn -> query("SELECT * FROM sections where path like 's_%' ORDER BY title") as $section) {
		$dbJs = $dbJs.
				"{".
				"title : '".str_replace("'", "\'", $section["title"])."',".
				"path : '".$section["path"]."',".
				"recipes : [";
		
		// recipes array
		foreach ($conn -> query("SELECT * FROM recipes WHERE section_path = '".$section["path"]."' order by title") as $recipe) {
			$dbJs = $dbJs.
					"{".
					 "shortTitle : '".str_replace("'", "\'", $recipe["short_title"])."',".
					 "title : '".str_replace("'", "\'", $recipe["title"])."',".
					 "path : '".$recipe["path"]."',".
					 "ingredientsAddition : '".str_replace("'", "\'", $recipe["ingredients_addition"])."',".
					 "ingredientsLeft : '".str_replace("'", "\'", $recipe["ingredients_left"])."',".
					 "ingredientsRight : '".str_replace("'", "\'", $recipe["ingredients_right"])."',".
					 "preparingAddition : '".str_replace("'", "\'", $recipe["preparing_addition"])."',".
					 "preparing : '".str_replace("'", "\'", $recipe["preparing"])."',".
					 "section : null".
					 "},";
		}
		
		$dbJs = $dbJs."]},";
	}
	
	$dbJs = $dbJs."],".
			"recipes : []".
			"};".
			"db.sections.forEach(function(section) {".
			"	section.recipes.forEach(function(recipe) {".
			"		recipe.section = section;".
			"		db.recipes.push(recipe);".
			"		db.recipes[recipe.path] = recipe;".
			"	});".
			"});";
	
	return $dbJs;
}

/**
 * Generate prompt for authentication.
 */
function passwordJs() {
	if (!isAuthenticated()) {
		return "j(function() {".
			"	j.confirm({".
			"		title: 'Login',".
			"		boxWidth: '360px',".
			"		useBootstrap: false,".
			"		content: '<div>Zum Schreibzugriff bitte Kennwort eingeben<br/><input id=\"password\" type=\"password\" placeholder=\"Kennwort\"/></div>',".
			"		buttons: {".
			"			formSubmit: {".
			"				text: 'Best&auml;tigen',".
			"				action: function() {".
			"					var password = this.\$content.find('#password').val();".
			"					if(!password){".
			"						alert('Bitte Kennwort eingeben');".
			"						return false;".
			"					}".
			"					j('form').append('<input type=\"hidden\" name=\"auth\" value=\"'+ password + '\"/>');".
			"				}".
			"			},".
			"			cancel: {".
			"				text: 'Nur Lesezugriff',".
			"				action: function() {".
			"					j('.buttonpanel').hide();".
			"					connectionToServer = false;".
			"				}".
			"			}".
			"		}".
			"	});".
			"});";
	}
	else {
		return "j(function() {j('form').append('<input type=\"hidden\" name=\"auth\" value=\"".$GLOBALS['authPassword']."\"/>');});";
	}	
}

?>